#!/bin/sh
#19.10.2010
##############Änderbare Variablen###############
VSNDMAN=$4 #manuelle SecondStageLoader Version, wird hier ein Wert eingegeben, dann wird dieser Wert immer benutzt! Unabhängig der Ermittlungen über ipkg-list oder IHAD
################################################

DIRECTORY=`echo "$1" | sed -e "s/\/*$/\1/"`
DEBUG=$3

#################Exit cleanup################
for sig in 0 1 2 3 6 14 15; do
	trap "cleanup $sig" $sig
done

#echo "$1 $2 $3 $4"
cleanup() {
	EXIT_CODE=$?
	if [ $EXIT_CODE = 130 ] ; then
		echo " "
		echo "**************************"
		echo "* Abbruch durch Benutzer *"
		echo "**************************"
	fi
	if [ -s "$SWAPDIR"/swapfile_backup ] ; then #Überprüfen ob Swapfile von Script erstellt wurde, wenn ja löschen
		# start mod by JackDaniel
		swapoff $SWAPDIR/swapfile_backup 2> /dev/null
		rm -rf $SWAPDIR/swapfile_backup
		echo " "
		echo "----------------------------------------"
		echo "Deaktiviere und lösche Swap  "
		echo "----------------------------------------"
	fi
	
	mountedroot=`mount | grep /tmp/bi/root | cut -d " " -f3`
	mountedboot=`mount | grep /tmp/bi/boot | cut -d " " -f3`
	if [ "$mountedroot" = "/tmp/bi/root" -o "$mountedboot" = "/tmp/bi/boot" ]; then
		umount /tmp/bi/root 2> /dev/null
		umount /tmp/bi/boot 2> /dev/null
		echo " "
		echo "----------------------------------------"
		echo "umount /tmp/bi/root"
		echo "umount /tmp/bi/boot"
		echo "----------------------------------------"
	fi
	rm -rf /tmp/secondstage.bin
	rm -rf /tmp/bi
	rm -rf $DIRECTORY/bi
	echo " "
	echo "----------------------------------------"
	echo "- Bei Fragen www.i-have-a-dreambox.com -"
	echo "-  sollte ein Fehler aufgelaufen sein  -"
	echo "-  bitte /tmp/FlashBackupLog           -"
	echo "-  im Thread posten                    -"
	echo "----------------------------------------"

	echo "exit "$EXIT_CODE
#	echo "exit "$EXIT_CODE > /tmp/"exit-code"
	trap - 0 # Exit Handler deaktivieren
	exit $EXIT_CODE
}
#MTDBLOCK=`df -h | grep "mtdblock" | cut -d " " -f1 | head -n1`
#MTDBLOCK=`cat /etc/fstab | grep "mtdblock" | cut -d " " -f1 | head -n1`
#if [ $MTDBLOCK = "/dev/mtdblock/2" -o $MTDBLOCK = "/dev/mtdblock/3" ] 2> /dev/null ;then
#	MTDBOOT=/dev/mtdblock/2
#	MTDROOT=/dev/mtdblock/3
#elif [ $MTDBLOCK = "/dev/mtdblock2" -o $MTDBLOCK = "/dev/mtdblock3" ] 2> /dev/null ;then
#	MTDBOOT=/dev/mtdblock2
#	MTDROOT=/dev/mtdblock3
if [ -e /dev/mtdblock2 ]; then
	MTDBOOT=/dev/mtdblock2
	MTDROOT=/dev/mtdblock3
elif [ -e /dev/mtdblock/2 ]; then
	MTDBOOT=/dev/mtdblock/2
	MTDROOT=/dev/mtdblock/3
else
	echo "Keine mtdblocks gefunden"
	exit 1
fi
#SWAPDIR=$DIRECTORY/backup/FlashBackup
#SSLDIR=$DIRECTORY/backup/FlashBackup/SSL

SWAPSIZE=$2
if [ "$SWAPSIZE" -lt 1 ]; then
	SWAPSIZE=128
fi

if grep -qs 7020 /proc/bus/dreambox ; then
	BOXTYPE=dm7020
	OPTIONS="--eraseblock=0x4000 -n -b"
elif grep -qs DM600PVR /proc/bus/dreambox ; then
	BOXTYPE=dm600pvr
	OPTIONS="--eraseblock=0x4000 -n -b"
elif grep -qs DM500PLUS /proc/bus/dreambox ; then
	BOXTYPE=dm500plus
	OPTIONS="--eraseblock=0x4000 -n -b"
elif grep -qs 'ATI XILLEON HDTV SUPERTOLL' /proc/cpuinfo ; then
	BOXTYPE=dm7025
	OPTIONS="--eraseblock=0x4000 -n -l"
elif grep -qs 'dm7025' /proc/stb/info/model ; then
	BOXTYPE=dm7025
	OPTIONS="--eraseblock=0x4000 -n -l"
elif grep -qs 'dm8000' /proc/stb/info/model ; then
	BOXTYPE=dm8000
	OPTIONS="--eraseblock=0x20000 -n -l"
elif grep -qs 'dm800' /proc/stb/info/model ; then
	BOXTYPE=dm800
	OPTIONS="--eraseblock=0x4000 -n -l"
elif grep -qs 'dm500hd' /proc/stb/info/model ; then
	BOXTYPE=dm500hd
	OPTIONS="--eraseblock=0x4000 -n -l"
else
	echo "Keine unterstützte Dreambox gefunden !!!"
	exit 1
fi
# Edit by Erim Start
echo " "
echo "*********************"
echo "** $BOXTYPE gefunden **"
echo "*********************"
echo " "

echo "---------------------------------------------------------------"
############# Überprüfe ob Datenträger vorhanden ist, wenn nicht suche alternativen ###############
listdummy=ls "$DIRECTORY"/blabla 2> /dev/null
FREESIZE=`df -m "$DIRECTORY" | tr -s " " | tail -n1 | cut -d' ' -f4 | sed "s/Available/0/`
if ! [ "$FREESIZE" -gt "128" ]; then
	echo ""$DIRECTORY" kann nicht für das FlashBackup benutzt werden,weil zuwenig Speicherplatz vorhanden ist !"
	echo "Versuche alternativen Datenträger zu finden"
echo "---------------------------------------------------------------"
	DEVICE=`df -m | grep / | awk '{print $4 " " $1}' | sort -n | cut -d ' ' -f2 | tail -n1`
	DIRECTORY=`mount | grep $DEVICE | sort -n | cut -d ' ' -f3`
	FREESIZE=`df -m | grep / | awk '{print $4 " " $1}' | sort -n | cut -d ' ' -f1 | tail -n1`
	if [ "$FREESIZE" -lt "128" ]; then
		echo "Es konnte kein alternativer Datenträger ermittelt werden"
		echo "Vermutlich ist kein passender Datenträger gemountet"
		echo "---------------------------------------------------------------"
		exit 1
	else
		echo "Alternativer Datenträger=$DIRECTORY"
echo "---------------------------------------------------------------"
	fi
fi

############# Überprüfe freien Datenträgerplatz ###############
echo "Überprüfe ob 128MB auf $DIRECTORY frei sind"
if [ "$FREESIZE" -lt "128" ]; then
	echo "Freier Speicher="$FREESIZE"MB,breche FlashBackup ab"
	echo "---------------------------------------------------------------"
	exit 1
else
	echo "Freier Speicher="$FREESIZE"MB=OK"
	if [ $DEBUG = "debugon" ] 2> /dev/null ; then
		SWAPDIR=$DIRECTORY/backup/FlashBackup-Debug
		SSLDIR=$DIRECTORY/backup/FlashBackup-Debug/SSL
	else
		SWAPDIR=$DIRECTORY/backup/FlashBackup
		SSLDIR=$DIRECTORY/backup/FlashBackup/SSL
	fi
	echo "---------------------------------------------------------------"
fi
mkdir -p $SSLDIR
###############Überprüfe auf manuell gesetzten SSL############
if ! test -z "$VSNDMAN" -o -n "`echo \"$VSNDMAN\" | tr -d '[0-9]'`" ; then
	echo "Secondstageloaderversion manuell auf $VSNDMAN gesetzt"
	VSND=$VSNDMAN
else
	###SSL-Version Ermittlung 8000, 800, 7025,7020, 600, 500Plus und 500HD ######
		echo "Versuche Secondstageloaderversion aus der Ipkg-List zu finden"
	VSND=`ipkg list | grep dreambox-secondstage | cut -d' ' -f3 |cut -d'-' -f1 | tail -n 1`
	########## Check des SSL aus ipkg-list################
	if test -z "$VSND" -o -n "`echo \"$VSND\" | tr -d '[0-9]'`" ; then
		echo "- Keine Secondstageloaderversion in der Ipkg-List gefunden :("
		############Versuche Aktuellsten SSL von IHAD zu finden###############
		echo "Versuche aktuellste Secondstageloaderversion vom IHAD zu finden"
		wget -q http://www.i-have-a-dreambox.com/diverses/secondstageloader/$BOXTYPE -O /tmp/SSLs 2> /dev/null
		IHADSSL=`cat /tmp/SSLs 2> /dev/null | grep secondstage | cut -d'-' -f3 |cut -d'.' -f1 | tail -n 1`
		########Überprüfe ob IHAD-SSL gefunden wurde, wenn nein suche auf HDD #####
		if ! test -z "$IHADSSL" -o -n "`echo \"$IHADSSL\" | tr -d '[0-9]'`" ; then
			############ Suchtiefe dreamboxupdate = 5 #####################
			SearchSSL=`expr $IHADSSL "+" 5`
			echo "Versuche neuere SSL-Version als "$IHADSSL" auf Dreamboxupdate zu finden..."
			wget -q http://www.dreamboxupdate.com/download/7020/secondstage-$BOXTYPE-$IHADSSL.bin -O $SSLDIR/secondstage-$BOXTYPE-$IHADSSL.bin 2> /dev/null
			IHADSSL=`expr $IHADSSL "+" 1`
			while [ $IHADSSL -lt $SearchSSL ] ; do
				echo "- Starte Suche nach SSL-Version $IHADSSL... -"
				wget -q http://www.dreamboxupdate.com/download/7020/secondstage-$BOXTYPE-$IHADSSL.bin -O $SSLDIR/secondstage-$BOXTYPE-$IHADSSL.bin 2> /dev/null
				IHADSSL=`expr $IHADSSL "+" 1`
			done
			rm -rf /tmp/SSLs
			VSND=`find $SSLDIR -name "secondstage-$BOXTYPE-*.bin" | sort -n | tail -n 1 | sed -e "s/^.*-\(.*\)\..*$/\1/"` #sed schneidet zwischen -77. die 77 aus
		else
			echo "-Keinen SSL auf IHAD gefunden, Box vermutlich offline"
			echo "Suche auf $SSLDIR -"
			VSND=`find $SSLDIR -name "secondstage-$BOXTYPE-*.bin" | sort -n | tail -n 1 | sed -e "s/^.*-\(.*\)\..*$/\1/"` #sed schneidet zwischen -77. die 77 aus
		fi
	else
		echo "Secondstageloaderversion in der Ipkg-List gefunden"
	fi
fi
#############Überprüfe ob VSND ein numerischer Wert ist##################
if test -z "$VSND" -o -n "`echo \"$VSND\" | tr -d '[0-9]'`" ; then
	echo "***********************************************************************************"
	echo "* SSL konnt nicht ermittelt werden. Entweder ist Box offline oder ihr habt keinen *"
	echo "* Secondstageloader auf $SSLDIR liegen. Für ein Offline-Backup ladet auch         *"       
	echo "* den secondstageloader.bin und die *.bin.md5 runter und verschiebt ihn nach      *"
	echo "* $SSLDIR. Euren secondstageloader findet ihr hier                                *"
	echo "* Download www.i-have-a-dreambox.com/diverses/secondstageloader/$BOXTYPE          *"
	echo "***********************************************************************************"
	exit 1
else
	echo "-------------------------------------------------------------------"
	echo "Secondstageloaderversion "$VSND" wird für das FlashBackup benutzt"
	echo "-------------------------------------------------------------------"
#echo "******************"
#echo "** $BOXTYPE found **"
#echo "******************"

############Versuche Flash-Image zu ermitteln###########
if [ $BOXTYPE = "dm8000" -o $BOXTYPE = "dm800" -o $BOXTYPE = "dm7025" -o $BOXTYPE = "dm500hd" ] ;then
	echo "Versuche Flash-Image zu ermitteln"
	if grep -qs "url=http:\/\/www.i-have-a-dreambox.com" /etc/image-version ; then
#		IMAGEINFO=Gemini-`cat /etc/image-version | grep version | cut -d'2' -f1 | sed 's/.*\(.\{3\}\)$/\1/' | cut -b 1`.`cat /etc/image-version | grep version | cut -d'2' -f1 | sed 's/.*\(.\{2\}\)$/\1/'` # sed Befehl schnappt sich die letzten 3 Zeichen
		IMAGEINFO=Gemini-`cat /etc/issue | cut -d " " -f2 | cut -d "." -f1-2 | head -n 1` #sed 's/.*\(.\{2\}\)$/\1/'` # sed Befehl schnappt sich die letzten 3 Zeichen
		LINK="Link: http://www.ihad.tv"
		echo "$IMAGEINFO gefunden"
	elif [ `cat /etc/image-version | grep creator | sed "s/creator=//" | cut -d " " -f 1` = "OoZooN" ] ; then
		IMAGEINFO=OoZooN-CVS-`cat /etc/issue | cut -d " " -f2 | cut -d "." -f1-2 | head -n 1`
		LINK="Link: http://www.oozoon.de/progs/images/$BOXTYPE"
		echo "$IMAGEINFO gefunden"
	elif [ `cat /etc/image-version | grep creator | sed "s/creator=//" | cut -d " " -f 1` = "newnigma2" ] ; then
		IMAGEINFO=Newnigma-`cat /etc/image-version | grep catalog | sed 's/.*\(.\{3\}\)$/\1/'`
		echo "$IMAGEINFO gefunden"
		LINK="Link: http://www.newnigma2.to/"
	elif [ `cat /etc/image-version | grep creator | sed "s/creator=//" | cut -d " " -f 1` = "LT" ] ; then
		IMAGEINFO=LT-Team
		LINK="Link: http://www.lt-forums.org/"
		echo "$IMAGEINFO gefunden"
	elif [ `cat /etc/image-version | grep creator | sed "s/creator=//" | cut -d " " -f 1` = "MiLo" ] ; then
		IMAGEINFO=MiLo
		LINK="Link: http://www.pli-images.org/"
		echo "$IMAGEINFO gefunden"
	elif grep -qs "MerlinDownloadBrowser" /usr/lib/enigma2/python/Plugins/Extensions/AddOnManager/plugin.py ; then
		IMAGEINFO="Merlin-2.Excalibur"-`cat /etc/issue | cut -d " " -f2 | cut -d "." -f1-2 | head -n 1`
		LINK="Link: http://www.dreambox-tools.info/"
		echo "$IMAGEINFO gefunden"
	elif [ `cat /etc/image-version | grep creator | sed "s/creator=//" | cut -d " " -f 1` = "PLi" ] ; then
		IMAGEINFO=PLi
		LINK="Link: http://www.pli-images.org/"
		echo "$IMAGEINFO gefunden"
	else
		IMAGEINFO=FlashBackup
		LINK="Link: http://sources.dreamboxupdate.com/opendreambox/1.6/$BOXTYPE/experimental"
		echo "Konnte Image nicht ermitteln, benutze FlashBackup als Backupname"
	fi
else
	IMAGEINFO=FlashBackup
	echo "Konnte Image nicht ermitteln, benutze FlashBackup als Backupname"
fi
	echo "---------------------------------------------------------------"
DATE=`date +%Y-%m-%d@%H.%M.%S`
MKFS=/usr/bin/mkfs.jffs2
BUILDIMAGE=/usr/bin/buildimage
BACKUPIMAGE=$SWAPDIR/$IMAGEINFO-$BOXTYPE-$DATE-SSL-$VSND.nfi
SND=secondstage-$BOXTYPE-$VSND.bin

if [ ! -f $MKFS ] ; then
#	echo $MKFS" in /usr/bin nicht gefunden :("
	exit 1
fi
if [ ! -f $BUILDIMAGE ] ; then
	echo $BUILDIMAGE" in /usr/bin nicht gefunden :("
	exit 1
fi

############Überprüfe ob SSL auf HDD liegt, wenn nicht download SSL ##########
if [ -f $SSLDIR/$SND ] ; then
	cp -r $SSLDIR/$SND /tmp/secondstage.bin 2> /dev/null
	echo "SSL in $SSLDIR gefunden,benutze $SND"
else
	echo "...Download" $SND
	wget -q http://sources.dreamboxupdate.com/download/7020/$SND -O $SSLDIR/$SND > /dev/null
###########Überprüfe download####################
	if [ -f $SSLDIR/$SND ] ; then
		cp -r $SSLDIR/$SND /tmp/secondstage.bin 2> /dev/null
	else
		echo ""
		echo "##############################################################"
		echo "# "$SND" konnte nicht downgeloadet werden #"
		echo "# Vermutlich ist eure Box oder dreamboxupdate.com offline    #"
		echo "##############################################################"
		echo ""
		exit 1
	fi
fi
############### Prüfe ob MD5 Datei auf HDD liegt und #################
if ! [ -f $SSLDIR/$SND.md5 ] ; then
	echo "...Download" $SND.md5
	wget -q http://www.i-have-a-dreambox.com/diverses/secondstageloader/$BOXTYPE/$SND.md5 -O $SSLDIR/$SND.md5 > /dev/null
fi
echo "---------------------------------------------------------------"
####################MD5 check des SSL #################
if [ -s $SSLDIR/$SND.md5 ] ; then
	md5sum $SSLDIR/$SND > /tmp/SSL.md5
	#md5sum -c MD5SUM
	if [ -z `cat /tmp/SSL.md5 | cut -d' ' -f1` ] ; then
		echo " "
		echo "##################################"
		echo "# MD5 Überprüfung fehlgeschlagen #"
		echo "# Bitte FlashBackup erneut       #"
		echo "# ausführen                      #"
		echo "##################################"
		echo " "
		rm -r /tmp/SSL.md5
		rm -r $SSLDIR/$SND.md5
		rm -r $SSLDIR/$SND
		exit 1
	fi
	if [ `cat /tmp/SSL.md5 | cut -d' ' -f1` = `cat $SSLDIR/$SND.md5 | cut -d' ' -f1` ]; then 
		echo "MD5 Überprüfung=OK"
		rm -r /tmp/SSL.md5
	else
		echo " "
		echo "##################################"
		echo "# MD5 Überprüfung fehlgeschlagen #"
		echo "# Bitte FlashBackup erneut       #"
		echo "# ausführen                      #"
		echo "##################################"
		echo " "
		rm -r /tmp/SSL.md5
		rm -r $SSLDIR/$SND.md5
		rm -r $SSLDIR/$SND
		exit 1
	fi
else
	echo " "
	echo "##########################################################"
	echo "# $SND.md5 wurde nicht gefunden                          #"
	echo "# Vermutlich liegt diese noch nicht auf dem IHAD-Server  #"
	echo "# Setze Backup ohne MD5 Check fort                       #"
	echo "##########################################################"
	echo " "
fi
########################################################################
echo "---------------------------------------------------------------"

case "$DIRECTORY" in
	/media/net* )
		echo "Überspringe SWAP-Erstellung da auf Netzwerklaufwerk gesichert wird"
	;;
	* )
		echo "Prüfe freien Arbeitspeicher,es wird ca."$SWAPSIZE"MB benötigt"
		let MEMFREE=`free | grep Total | tr -s " " | cut -d " " -f 4 `/1024
		if [ "$MEMFREE" -lt $SWAPSIZE ]; then
			echo "Arbeitspeicher ist kleiner als "$SWAPSIZE"MB,FlashBackup muss eine Swapdatei erstellen"
			echo "---------------------------------------------------------------"
			# Edit by Erim Stop
			#start mod by JackDaniel
			echo "Erstelle Swap auf $SWAPDIR mit "$SWAPSIZE"MB"
			dd if=/dev/zero of=$SWAPDIR/swapfile_backup bs=1024k count=$SWAPSIZE
			mkswap $SWAPDIR/swapfile_backup
			swapon $SWAPDIR/swapfile_backup
			echo "---------------------------------------------------------------"
			echo "Swap aktiviert"
			echo "---------------------------------------------------------------"
			# end mod by JackDaniel
		else
			echo "Arbeitspeicher="$MEMFREE"MB=OK"
		fi
	;;
esac

	echo "***********************************************"
	#start mod by JackDaniel
	starttime="$(date +%s)"
	echo "* FlashBackup gestartet um: `date +%H:%M:%S`          *"
	echo "***********************************************"
	# end mod by JackDaniel
	rm -rf $DIRECTORY/bi
	mkdir -p $DIRECTORY/bi
	mkdir -p /tmp/bi/root
	mkdir -p /tmp/bi/boot
##################Image-Erstellung#######################
	mount -t jffs2 $MTDROOT /tmp/bi/root
	mount -t jffs2 $MTDBOOT /tmp/bi/boot

	if [ -s /tmp/secondstage.bin ] ; then
		echo "Erstelle boot.jffs2..."
		$MKFS --root=/tmp/bi/boot --faketime --output=$DIRECTORY/bi/boot.jffs2 $OPTIONS
		SZboot=`ls -al $DIRECTORY/bi/boot.jffs2 | awk '{print $5}'`
		echo "Erstelle root.jffs2..."
		$MKFS --root=/tmp/bi/root --faketime --output=$DIRECTORY/bi/root.jffs2 $OPTIONS
		SZroot=`ls -al $DIRECTORY/bi/root.jffs2 | awk '{print $5}'`
		echo "Erstelle SSL..."
		if [ $BOXTYPE = "dm800" -o $BOXTYPE = "dm8000" -o $BOXTYPE = "dm500hd" ] ; then
			cp /tmp/secondstage.bin $DIRECTORY/bi/main.bin.gz
		else
			gzip -c /tmp/secondstage.bin > $DIRECTORY/bi/main.bin.gz
		fi
		SZssl=`ls -al /tmp/secondstage.bin | awk '{print $5}'`
		rm -rf /tmp/secondstage.bin

		echo "Erstelle" $BOXTYPE "FlashBackup..."

			if [ $BOXTYPE = "dm7025" ] ; then
				$BUILDIMAGE $DIRECTORY/bi/main.bin.gz $DIRECTORY/bi/boot.jffs2 $DIRECTORY/bi/root.jffs2 $BOXTYPE > $BACKUPIMAGE
			elif [ $BOXTYPE = "dm800" ] ; then
				$BUILDIMAGE $DIRECTORY/bi/main.bin.gz $DIRECTORY/bi/boot.jffs2 $DIRECTORY/bi/root.jffs2 $BOXTYPE 64 > $BACKUPIMAGE
			elif [ $BOXTYPE = "dm8000" ] ; then
				$BUILDIMAGE $DIRECTORY/bi/main.bin.gz $DIRECTORY/bi/boot.jffs2 $DIRECTORY/bi/root.jffs2 $BOXTYPE 64 large > $BACKUPIMAGE
			elif [ $BOXTYPE = "dm7020" ] ; then
				$BUILDIMAGE $DIRECTORY/bi/main.bin.gz $DIRECTORY/bi/boot.jffs2 $DIRECTORY/bi/root.jffs2 > $BACKUPIMAGE
			elif [ $BOXTYPE = "dm600pvr" ] ; then
				$BUILDIMAGE $DIRECTORY/bi/main.bin.gz $DIRECTORY/bi/boot.jffs2 $DIRECTORY/bi/root.jffs2 $BOXTYPE > $BACKUPIMAGE
			elif [ $BOXTYPE = "dm500plus" ] ; then
				$BUILDIMAGE $DIRECTORY/bi/main.bin.gz $DIRECTORY/bi/boot.jffs2 $DIRECTORY/bi/root.jffs2 $BOXTYPE > $BACKUPIMAGE
			elif [ $BOXTYPE = "dm500hd" ] ; then
				$BUILDIMAGE $DIRECTORY/bi/main.bin.gz $DIRECTORY/bi/boot.jffs2 $DIRECTORY/bi/root.jffs2 $BOXTYPE 64 > $BACKUPIMAGE
			fi

SZimage=`ls -al $BACKUPIMAGE | awk '{print $5}'`
SZsum=`expr $SZboot "+" $SZroot "+" $SZssl`
SZdiff=`expr $SZimage "-" $SZsum`

########Abfrage Image erstellt ########
		if [ "$SZsum" -lt $SZimage ]; then
#		if [ -f $BACKUPIMAGE ] ; then
			echo "----------------------------------------------------------------------"
			echo "FlashBackup erstellt in:" $BACKUPIMAGE
			echo "----------------------------------------------------------------------"
			echo "Enigma2: Experimental " > $SWAPDIR/$IMAGEINFO-$BOXTYPE-$DATE-SSL-$VSND.nfo
			echo "Machine: Dreambox $BOXTYPE" >> $SWAPDIR/$IMAGEINFO-$BOXTYPE-$DATE-SSL-$VSND.nfo
			echo "Date: "$DATE | cut -d '@' -f1 | sed -e "s/-//g" >> $SWAPDIR/$IMAGEINFO-$BOXTYPE-$DATE-SSL-$VSND.nfo
			echo "Issuer: $IMAGEINFO" >> $SWAPDIR/$IMAGEINFO-$BOXTYPE-$DATE-SSL-$VSND.nfo
			echo $LINK >> $SWAPDIR/$IMAGEINFO-$BOXTYPE-$DATE-SSL-$VSND.nfo
			md5NFO=`md5sum $BACKUPIMAGE | cut -d ' ' -f1`
			echo "MD5: $md5NFO" >> $SWAPDIR/$IMAGEINFO-$BOXTYPE-$DATE-SSL-$VSND.nfo
		else
			echo "Download Error :("
			rm -rf $SWAPDIR/$IMAGEINFO-$BOXTYPE-$DATE-SSL-$VSND.nfi
			exit 1
		fi

	stoptime="$(date +%s)"
	elapsed_seconds="$(expr $stoptime - $starttime)"
	echo "***********************************************"
	echo "* FlashBackup beendet um: `date +%H:%M:%S`            *"
	echo "* Dauer des FlashBackups: $((elapsed_seconds / 60))Minuten $((elapsed_seconds % 60))Sekunden *"
	echo "***********************************************"
	# end mod by JackDaniel
	fi
fi
exit
